(* Name:
 * CS611
 *)

structure Translate : TRANSLATE = struct

  local open LambdaAst in

  exception Translate of string

  (* Contexts map variables to expressions.  They should be helpful when *)
  (* translating letrec expressions. *)
  type ctxt = (var * expr) list

  (* Adds a new binding for a variable in a context. *)
  fun add (ctxt : ctxt) (v, e) = 
    (v,e)::ctxt

  (* Looks up a variable in a context *)
  fun lookup (x, _) [] = NONE
    | lookup v ((x, e)::rest) =
    if eqvar v x then SOME e else lookup v rest

  fun translate e =
    let 
      fun translate' ctxt (Num n) = Num n
	| translate' ctxt (Lambda ([x],e)) = 
	let 
	  val e' = translate' ctxt e
	in 
	  Lambda ([x], e')
	end
      (* Here's one way to encode left/right; feel free to use another
       * encoding if you wish.
       *)
	| translate' ctxt (Left e) = 
	  let val l = newvar "l";
	    val r = newvar "r";
	  in Lambda([l],Lambda([r], App[Var l, translate' ctxt e]))
	  end
	| translate' ctxt (Right e) = 
	  let val l = newvar "l";
	    val r = newvar "r";
	  in Lambda([l],Lambda([r], App[Var r, translate' ctxt e]))
	  end
	| translate' ctxt e = raise (Translate"unimplemented")
    in
      translate' [] e
    end
  
  (* These definitions rely on the translation of Left/Right and Num. 
   * If you change those definitions, these values change also. *)
  val transTrue = translate astTrue
  val transFalse = translate astFalse

  end
end

